C************************************************************************
C******                                                          ********
C******                     Committee Model                      ********
C******         Combination of predictions of committee models   ********
C******                                                          ********
C******  SREE HARSHA  LALAM  University of Cambridge   15/6/2000 ********
C************************************************************************
C
C This program produces the energy of all data trained using all predictions 
C data by committee models.
C
C (1)Maximum number of models in committee = 200
C (2) Compile and run.
C     The name of output is "com.dat" and input file is RESULT.DAT
C ***********************************************************************
C imodel: the number of models used.
C
C RESULT.DAT:     the file name where _out files PREDICTED using all data
C            exsists.
C
C
C outfile includes _out files trained using all data.
C
C _out is prediction, standard deviation, minmum and maximum.
C _ot  is target + _out
C
C************************************************************************

      implicit double precision (a-h,l-z), integer(i,j)
      
      double precision ave(200),dev(200),avesum,D(800)
C    &aveave,varave,avevar,devcom,varcom,min,max,varsum
      
       open(unit=44,file='s/committee.dat')  
	open(unit=11,file='no_of_rows.dat')
	open(unit=12,file='RESULT.DAT')
	open(unit=13,file='com.dat')



 	read(44,*)imodel,icol
	iicol=imodel*4
C       
C THIS FILE READS NO oF DATA from input file "no_of_rows"

C
	read(11,*)irow
  
C ***********************************************************************


      open(3,FILE='com.dat')

	do 999 I=1,irow
C Read all committee model results for one line of inputs
	read(12,*)(D(J),J=1,iicol)

C TAKE ONLY THE FIRST TWO COLUMNS IN EACH PREDICTION

	do 11 J=1,imodel
	JJ=(J-1)*4+1
	JJJ=JJ+1
	ave(J)=D(JJ)
	dev(J)=D(JJJ)
11	continue

C ***********************************************************************
     
      avesum=0.0
      varsum=0.0
      aveave=0.0
      varave=0.0

C Getting Average values of _out

       do 400 imodeln=1,imodel

            avesum=avesum+ave(imodeln)
            varsum=varsum+dev(imodeln)**2

400      continue
 
            aveave=avesum/dble(imodel)
            varave=varsum/dble(imodel)
C ***********************************************************************
          avevar=0.0
          varcom=0.0
          devcom=0.0    

        do 210 imodeln=1,imodel
          avevar=avevar+(aveave-ave(imodeln))**2  
210      continue

       varcom=varave+avevar/dble(imodel)
       devcom=sqrt(varcom)

     
       min=aveave-devcom
       max=aveave+devcom
       write(*,120) aveave,devcom,min,max
       write(13,120) aveave,devcom,min,max
999    continue

120    format(' ',F15.7,' ',F15.7,' ',F15.7,' ',F15.7)

      stop
      end
